{	This file has been processed by The THINK Pascal Source Converter, v1.1.	}
{}
{	Copyright  Symantec Corporation 1990}
{    Copyright Apple Computer, Inc. 1985-1990}
{    All rights reserved.}
{}
{}
{	File:		SoundInput.p}
{}
{Converted from the 6.0.6  beta 19 interfaces -MYG }

unit SoundInput;
interface


	const

{Error codes}

		siNoSoundInHardware = -220;			{  not used anywhere! }
		siBadSoundInDevice = -221;			{ invalid index passed to SoundInGetIndexedDevice }
		siNoBufferSpecified = -222;			{ returned by synchronous SPBRecord if nil buffer passed }
		siInvalidCompression = -223;			{ invalid compression type }
		siHardDriveTooSlow = -224;			{ hard drive too slow to record to disk }
		siInvalidSampleRate = -225;			{ invalid sample rate }
		siInvalidSampleSize = -226;			{ invalid sample size }
		siDeviceBusyErr = -227;			{ input device already in use }
		siBadDeviceName = -228;			{ input device could not be opened }
		siBadRefNum = -229;			{ invalid input device reference number }
		siInputDeviceErr = -230;			{ input device hardware failure }
		siUnknownInfoType = -231;			{ invalid info type selector (returned by driver) }
		siUnknownQuality = -232;			{ invalid quality selector (returned by driver) }

		siDeviceIsConnected = 1;				{ input device is connected and ready for input }
		siDeviceNotConnected = 0;				{ input device is not connected }
		siDontKnowIfConnected = -1;				{ can't tell if input device is connected }

		siReadPermission = 0;				{ permission passed to SPBOpenDevice }
		siWritePermission = 1;				{ permission passed to SPBOpenDevice }

{ Info Selectors for Sound Input Drivers }

		siDeviceConnected = 'dcon';			{ input device connection status }
		siRTFOnOff = 'rtf ';			{ record to file state }
		siAGCOnOff = 'agc ';			{ automatic gain control state }
		siPlayThruOnOff = 'plth';			{ playthrough state }
		siTwosComplementOnOff = 'twos';			{ two's complement state }
		siLevelMeterOnOff = 'lmet';			{ level meter state }
		siPauseRecording = 'paus';			{ recording paused state }
		siRecordingQuality = 'qual';			{ recording quality }
		siVoxRecordInfo = 'voxr';			{ VOX record parameters }
		siVoxStopInfo = 'voxs';			{ VOX stop parameters }
		siNumberChannels = 'chan';			{ current number of channels }
		siSampleSize = 'ssiz';			{ current sample size }
		siSampleRate = 'srat';			{ current sample rate }
		siCompressionType = 'comp';			{ current compression type }
		siCompressionFactor = 'cmfa';			{ current compression factor }
		siCompressionHeader = 'cmhd';			{ return compression header }
		siUserInterruptProc = 'user';			{ user interrupt routine }
		siDeviceName = 'name';			{ input device name }
		siDeviceIcon = 'icon';			{ input device icon }
		siDeviceBufferInfo = 'dbin';			{ size of interrupt buffer }
		siSampleSizeAvailable = 'ssav';			{ sample sizes available }
		siSampleRateAvailable = 'srav';			{ sample rates available }
		siCompressionAvailable = 'cmav';			{ compression types available }
		siChannelAvailable = 'chav';			{ number of channels available }
		siInitializeDriver = 'init';			{ initialize driver }
		siCloseDriver = 'clos';			{ close driver }
		siAsync = 'asyn';			{ asynchronous capability }
		siOptionsDialog = 'optd';			{ display options dialog }

{ Qualities }

		siBestQuality = 'best';
		siBetterQuality = 'betr';
		siGoodQuality = 'good';


{ Function selectors for the Sound Input calls }

		siToolNum = 20;				{ tool number of Sound Input Manager }
		siMOVEL = $203C;			{ MOVEI.L	#selector,D0 }

		siVersion = (0 * 256) + 0;
		siSndRecord = (8 * 256) + 4;
		siSignInDevice = (3 * 256) + 12;
		siSignOutDevice = (1 * 256) + 16;
		siGetIndexedDevice = (5 * 256) + 20;
		siOpenDevice = (5 * 256) + 24;
		siCloseDevice = (2 * 256) + 28;
		siRecord = (3 * 256) + 32;
		siPauseRecordingR = (2 * 256) + 40;
		siResumeRecording = (2 * 256) + 44;
		siStopRecording = (2 * 256) + 48;
		siGetRecordingStatus = (14 * 256) + 52;
		siGetDeviceInfo = (6 * 256) + 56;
		siSetDeviceInfo = (6 * 256) + 60;
		siMilliSecondsToBytes = (4 * 256) + 64;
		siBytesToMilliSeconds = (4 * 256) + 68;
		siSetupSndHeader = (13 * 256) + 72;
		siSetupAIFFHeader = (11 * 256) + 76;


	type

		SPBPtr = ^SPB;
		SPB = record
				inRefNum: LONGINT;			{ reference number of sound input device }
				count: LONGINT;			{ number of bytes to record }
				milliseconds: LONGINT;			{ number of milliseconds to record }
				bufferLength: LONGINT;			{ length of buffer in bytes }
				bufferPtr: Ptr;				{ buffer to store sound data in }
				completionRoutine: ProcPtr;			{ completion routine }
				interruptRoutine: ProcPtr;			{ interrupt routine }
				userLong: LONGINT;			{ user-defined field }
				error: OSErr;				{ error }
				unused1: LONGINT;			{ reserved - must be zero }
			end;


	function SPBVersion: LONGINT;
	inline
		siMOVEL, siVersion, siToolNum, $A800;

	function SndRecord (filterProc: ProcPtr; corner: Point; quality: OSType; var sndHandle: Handle): OSErr;
	inline
		siMOVEL, siSndRecord, siToolNum, $A800;

	function SPBSignInDevice (deviceRefNum: INTEGER; deviceName: Str255): OSErr;
	inline
		siMOVEL, siSignInDevice, siToolNum, $A800;

	function SPBSignOutDevice (deviceRefNum: INTEGER): OSErr;
	inline
		siMOVEL, siSignOutDevice, siToolNum, $A800;

	function SPBGetIndexedDevice (count: INTEGER; var deviceName: Str255; var deviceIconHandle: Handle): OSErr;
	inline
		siMOVEL, siGetIndexedDevice, siToolNum, $A800;

	function SPBOpenDevice (deviceName: Str255; permission: INTEGER; var inRefNum: LONGINT): OSErr;
	inline
		siMOVEL, siOpenDevice, siToolNum, $A800;

	function SPBCloseDevice (inRefNum: LONGINT): OSErr;
	inline
		siMOVEL, siCloseDevice, siToolNum, $A800;

	function SPBRecord (inParamPtr: SPBPtr; asynchFlag: BOOLEAN): OSErr;
	inline
		siMOVEL, siRecord, siToolNum, $A800;

	function SPBPauseRecording (inRefNum: LONGINT): OSErr;
	inline
		siMOVEL, siPauseRecordingR, siToolNum, $A800;

	function SPBResumeRecording (inRefNum: LONGINT): OSErr;
	inline
		siMOVEL, siResumeRecording, siToolNum, $A800;

	function SPBStopRecording (inRefNum: LONGINT): OSErr;
	inline
		siMOVEL, siStopRecording, siToolNum, $A800;

	function SPBGetRecordingStatus (inRefNum: LONGINT; var recordingStatus: INTEGER; var meterLevel: INTEGER; var totalSamplesToRecord: LONGINT; var numberOfSamplesRecorded: LONGINT; var totalMsecsToRecord: LONGINT; var numberOfMsecsRecorded: LONGINT): OSErr;
	inline
		siMOVEL, siGetRecordingStatus, siToolNum, $A800;

	function SPBGetDeviceInfo (inRefNum: LONGINT; infoType: OSType; infoData: Ptr): OSErr;
	inline
		siMOVEL, siGetDeviceInfo, siToolNum, $A800;

	function SPBSetDeviceInfo (inRefNum: LONGINT; infoType: OSType; infoData: Ptr): OSErr;
	inline
		siMOVEL, siSetDeviceInfo, siToolNum, $A800;

	function SPBMilliSecondsToBytes (inRefNum: LONGINT; var milliSeconds: LONGINT): OSErr;
	inline
		siMOVEL, siMilliSecondsToBytes, siToolNum, $A800;

	function SPBBytesToMilliSeconds (inRefNum: LONGINT; var byteCount: LONGINT): OSErr;
	inline
		siMOVEL, siBytesToMilliSeconds, siToolNum, $A800;

	function SetupSndHeader (sndHandle: Handle; numChannels: INTEGER; sampleRate: Fixed; sampleSize: INTEGER; compressionType: OSType; baseNote: INTEGER; numBytes: LONGINT; var headerLen: INTEGER): OSErr;
	inline
		siMOVEL, siSetupSndHeader, siToolNum, $A800;

	function SetupAIFFHeader (fRefNum: INTEGER; numChannels: INTEGER; sampleRate: Fixed; sampleSize: INTEGER; compressionType: OSType; numBytes: LONGINT; numFrames: LONGINT): OSErr;
	inline
		siMOVEL, siSetupAIFFHeader, siToolNum, $A800;

    { UsingSoundInput }


implementation
end.